export declare type Value = (number | string);
export declare type StringToken = string;
export declare type GetToken = {
    todo: 'get';
    args: Value[];
    inner: Token[];
};
export declare type IfToken = {
    todo: 'if';
    args: Value[];
    inner: Token[];
};
export declare type RenderToken = {
    todo: 'render';
    args: Value[];
};
export declare type EndToken = {
    todo: 'fi' | 'teg' | 'else';
};
export declare type Token = StringToken | GetToken | IfToken | RenderToken | EndToken;
/**
 * 吧输入处理为数组: '123 asd' => parseToArr => [123, 'asd']
 * @param str
 */
export declare function parseToArr(str: string): Value[];
/**
 *
 * @param token
 */
export declare function tokenParser(token: string): GetToken | IfToken | RenderToken | EndToken;
/**
 * 获取 statement
 * @param { String } str 模板
 */
export declare function getToken(str: string): Token[];
export declare function tokenFold(tokens: Token[]): Token[];
